//
//  ViewController.swift
//  Swift_JSON
//
//  Created by Jon Hoffman on 12/26/14.
//  Copyright (c) 2014 Jon Hoffman. All rights reserved.
//

import UIKit

class ViewController: UIViewController {
    
    var jsonString = "{\"books\": [{\"name\": \"iOS and OS X Network Development Cookbook\",\"publisher\": \"PacktPub\",\"category\": \"Programming\",\"description\": \"Network development for iOS and OS X\"},{\"name\": \"Mastering Swift\",\"author\": \"Jon Hoffman\",\"publisher\": \"PacktPub\",\"category\": \"Programming\",\"description\": \"Learning Swift\"}]}"
    
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
        do {
            try parseJson()
        } catch _ {}
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
        
    }
    
    func parseJson() throws {
        var myBooks: [Book] = []
        let jsonData = jsonString.data(using: String.Encoding.utf8)
        if let data = jsonData {
            let jsonDoc : Any = try JSONSerialization.jsonObject(with: data, options: JSONSerialization.ReadingOptions.allowFragments)
            
            if let books = (jsonDoc as AnyObject).object(forKey: DocTags.BOOKS_TAG) as? NSArray {
                
                for i in 0 ..< books.count {
                    if let dict = books[i] as? NSDictionary {
                        let book = Book()
                        addElementToBook(book, elementName: DocTags.AUTHOR_TAG, elementValue: (dict.object(forKey: DocTags.AUTHOR_TAG) as? String))
                        addElementToBook(book, elementName: DocTags.CATEGORY_TAG, elementValue: (dict.object(forKey: DocTags.CATEGORY_TAG) as? String))
                        addElementToBook(book, elementName: DocTags.DESCRIPTION_TAG, elementValue: (dict.object(forKey: DocTags.DESCRIPTION_TAG) as? String))
                        addElementToBook(book, elementName: DocTags.NAME_TAG, elementValue: (dict.object(forKey: DocTags.NAME_TAG) as? String))
                        addElementToBook(book, elementName: DocTags.PUBLISHER_TAG, elementValue: (dict.object(forKey: DocTags.PUBLISHER_TAG) as? String))
                        myBooks.append(book)
                    }
                }
                
                for book in myBooks {
                    print("Found - \(book.name) \(book.author)")
                }
                
                
                let myDict = [DocTags.BOOKS_TAG:books]
                do {
                    print("Str:  \(try buildJSON(myDict as AnyObject))")
                } catch {}
            }
        }
    }
    
    func addElementToBook(_ book: Book, elementName: String, elementValue: String?) {
        if let value = elementValue {
            book.addValue(elementName, withValue: value)
        }
    }
    
    
    func buildJSON(_ value: AnyObject) throws -> String {
        if JSONSerialization.isValidJSONObject(value) {
            let data = try JSONSerialization.data(withJSONObject: value, options: [])
            if let string = String(data: data, encoding: String.Encoding(rawValue: String.Encoding.utf8.rawValue)) {
                return string as String
            }
        }
        return ""
    }
    
    
}

